/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef _CALLTREEWIDGET_H
#define _CALLTREEWIDGET_H

#include <QMenu>
#include <QFile>
#include "CubeMetric.h"
#include "CubeRegion.h"
#include "CubeSysres.h"

#include "TreeWidgetItem.h"
#include "TreeWidget.h"
#include "Action.h"
#include "Coloring.h"
#include "MyTreeWidget.h"
#include "ScrollArea.h"

//the TreeWidget class extends MyTreeWidget basically by value computations

class CallTreeWidget : public TreeWidget
{
public:

    CallTreeWidget( QWidget*            parent,
                    QString             cubeFileName = "",
                    cubeparser::Driver* driver = NULL,
                    Statistics*         statistics = 0 ) : TreeWidget( parent, CALLTREE, cubeFileName, driver, statistics )
    {
    };
    virtual
    ~CallTreeWidget()
    {
    };

// reimplement the call computeValues

    virtual void
    computeValue( cube::list_of_metrics& mv,
                  TreeWidgetItem*        item );
    virtual void
    computeValue( cube::list_of_metrics&      mv,
                  cube::list_of_sysresources& sv,
                  TreeWidgetItem*             item );

    virtual void
    computeBasicValues();

    // TabInterface interface
    QIcon
    icon() const;

    std::vector<TreeWidgetItem*>
    selectedItemsAndIterations();

protected:
    void
    onSelection();

private:
    std::vector<TreeWidgetItem*> selectedAndIterations;
    void
    computeValueHiddenIterations( cube::list_of_metrics&         mv,
                                  cube::list_of_sysresources&    sv,
                                  TreeWidgetItem*                item,
                                  const vector<TreeWidgetItem*>& iterations );
    void
    computeValueHiddenIterationsFirstLevel( cube::list_of_metrics&      mv,
                                            cube::list_of_sysresources& sv,
                                            TreeWidgetItem*             item );
};


#endif
