/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef _FLATTREEWIDGET_H
#define _FLATTREEWIDGET_H

#include <QMenu>
#include <QFile>
#include "CubeMetric.h"
#include "CubeRegion.h"
#include "CubeSysres.h"

#include "TreeWidgetItem.h"
#include "TreeWidget.h"
#include "Action.h"
#include "Coloring.h"
#include "MyTreeWidget.h"
#include "ScrollArea.h"

//the TreeWidget class extends MyTreeWidget basically by value computations

class FlatTreeWidget : public TreeWidget
{
public:

    FlatTreeWidget( QWidget*            parent,
                    QString             cubeFileName = "",
                    cubeparser::Driver* driver = NULL,
                    Statistics*         statistics = 0 ) : TreeWidget( parent, CALLFLAT, cubeFileName, driver, statistics )
    {
    };
    virtual
    ~FlatTreeWidget()
    {
    };

// reimplement the call computeValues


    virtual void
    computeValue( cube::list_of_metrics& mv,
                  TreeWidgetItem*        item );
    virtual void
    computeValue( cube::list_of_metrics&      mv,
                  cube::list_of_sysresources& sv,
                  TreeWidgetItem*             item );
    virtual void
    computeBasicValues();

    // TabInterface interface
    QIcon
    icon() const;
};


#endif
