/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef _MESSAGEWIDGET_H
#define _MESSAGEWIDGET_H

#include <QWidget>
#include <QLabel>
//MessageWidget shows a warning message for N seconds and dissapears.
// It dissapears,if user clicks on ot.


// Different kind of hints are possible: hint, warning, Error.
enum HintKind { Hint = 0, Warning = 1, Error = 2, Message = 3, PermanentMessage = 4, PermanentError = 5 };


class MessageWidget : public QWidget
{
    Q_OBJECT

protected slots:
    void
    closing();

public:

    MessageWidget( HintKind,
                   QString );


    void
    setMessage( HintKind,
                QString );

protected:



    /************** protected fields *****************/
    QString warning_message;
    QLabel* label;

    HintKind mykind;

    //mouse event handling
    void
    mousePressEvent( QMouseEvent* );
};

#endif
