/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef _METRICTREEWIDGET_H
#define _METRICTREEWIDGET_H

#include <QMenu>
#include <QFile>


#include "CubeMetric.h"
#include "CubeRegion.h"
#include "CubeSysres.h"

#include "TreeWidgetItem.h"
#include "TreeWidget.h"
#include "Action.h"
#include "Coloring.h"
#include "MyTreeWidget.h"
#include "ScrollArea.h"

//the TreeWidget class extends MyTreeWidget basically by value computations

class MetricTreeWidget : public TreeWidget
{
public:

    MetricTreeWidget( QWidget*            parent,
                      QString             cubeFileName = "",
                      cubeparser::Driver* driver = NULL,
                      Statistics*         statistics = 0 ) : TreeWidget( parent, METRICTREE, cubeFileName, driver, statistics )
    {
    };
    virtual
    ~MetricTreeWidget()
    {
    };

// reimplement the call computeValues

    virtual void
    computeValue( TreeWidgetItem* item );
    virtual void
    computeValue( cube::list_of_cnodes& cv,
                  TreeWidgetItem*       item );
    virtual void
    computeValue( cube::list_of_regions& rv,
                  TreeWidgetItem*        item );
    virtual void
    computeValue( cube::list_of_sysresources& sv,
                  TreeWidgetItem*             item );

    virtual void
    computeValue( cube::list_of_regions&      rv,
                  cube::list_of_sysresources& sv,
                  TreeWidgetItem*             item );
    virtual void
    computeValue( cube::list_of_cnodes&       cv,
                  cube::list_of_sysresources& sv,
                  TreeWidgetItem*             item );

    virtual void
    computeBasicValues();

    // TreeWidget interface

    // TabInterface interface
    QIcon
    icon() const;
};


#endif
