/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef PARAVER_CONNECTER_H
#define PARAVER_CONNECTER_H

#include "VisualizationConnecter.h"

#include <string>

class ParaverConnecter : public VisualizationConnecter
{
public:
    ParaverConnecter( std::string const& file,
                      std::string const& configFile,
                      bool               verbose );
    virtual std::string
    InitiateAndOpenTrace();
    virtual std::string
    ZoomIntervall( double start,
                   double end,
                   int    zoomStep );
    virtual bool
    IsActive() const;

    virtual
    ~ParaverConnecter();
private:
    int         childID;
    std::string fileName;
    std::string configFileName;
    std::string commFileName;
    bool        verbose;
};

#endif
