/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef _SCROLLAREA_H
#define _SCROLLAREA_H

#include <QWidget>
#include <QSplitter>

#if QT_VERSION < 0x050000
#include <QMotifStyle>
#endif


class SplitterContainer : public QSplitter
{
private:
    QStyle* mystyle;
public:
    SplitterContainer() : QSplitter( Qt::Vertical )
    {
#if QT_VERSION < 0x050000
        // make splitter more noticeable
        mystyle = new  QMotifStyle; // QWindowsStyle, QPlastiqueStyle
        setStyle( mystyle );
#endif
    }

#if QT_VERSION < 0x050000
    ~SplitterContainer()
    {
        delete mystyle;
    }
#endif
};

#include <QScrollArea>

class ScrollArea : public QScrollArea
{
public:
    ScrollArea( QWidget* parent ) : QScrollArea( parent )
    {
        this->setWidgetResizable( true ); // allow contents to resize

        //bars should be always displayed
        setHorizontalScrollBarPolicy( Qt::ScrollBarAlwaysOn );
        setVerticalScrollBarPolicy( Qt::ScrollBarAlwaysOn );
    }
};

#endif
