/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef SYSTEMBOXPLOT_H
#define SYSTEMBOXPLOT_H

#include <QWidget>

#include "BoxPlot.h"
#include "SystemTreeWidget.h"
#include "ValueWidget.h"

class SystemBoxPlot : public BoxPlot, public TabInterface
{
public:
    SystemBoxPlot( QWidget*          parent,
                   SystemTreeWidget* t );
    void
    updateValueWidget();

    QWidget*
    widget();

private:
    Item
    calculateStatistics( bool absolute );

    SystemTreeWidget*  systemTreeWidget; // contains data to display
    ValueWidget*       valueWidget;
    SplitterContainer* container;
    ScrollArea*        scrollArea;
    QComboBox*         subsetCombo;

public:
    void
    setSubsetCombo( QComboBox* );

    // TabInterface implementation
    QString
    label() const
    {
        return "BoxPlot";
    };
    void
    valueModusChanged()
    {
    }
    bool
    loadSettings( QSettings& )
    {
        return true;
    }
    void
    saveSettings( QSettings& )
    {
    }
    void
    valuesChanged();

    // TabInterface interface
    QIcon
    icon() const;

    // TabInterface interface
    void
    setActive();
};

#endif // SYSTEMBOXPLOT_H
