/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef VAMPIR_CONNECTION_DIALOG_H
#define VAMPIR_CONNECTION_DIALOG_H

#include <QDialog>
#include <QLineEdit>
#include <QPushButton>
#include <QSpinBox>
#include <QCheckBox>
#include "Action.h"
#include <QThread>

#include "Statistics.h"

class VampirConnectionThread;

class VampirConnectionDialog : public QDialog
{
    Q_OBJECT
public:
    VampirConnectionDialog( QWidget*    par,
                            QLineEdit*& fileEdit,
                            Statistics* stat,
                            MainWidget* mainWid );
    void
    setError( std::string const& title,
              std::string const& message );

    virtual
    ~VampirConnectionDialog();
private:
    QLineEdit*              fileLine;
    QLineEdit*              hostLine;
    QSpinBox*               portLine;
    QPushButton*            fileButton;
    QPushButton*            cancelButton;
    QPushButton*            okButton;
    QCheckBox*              fromServerCheckbox;
    Statistics*             statistics;
    VampirConnectionThread* connectionThread;
    std::string             errorTitle, errorMessage;
private slots:
    void
    establishVampirConnection();
    void
    printError();
};

#endif
