/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

/**
 * \file CubeWideSearchEnumerator.cpp
 * \brief Implements methods of the object WideSearchEnumerator.
 */
#ifndef CUBE_WIDE_SEARCH_ENUMERATOR_CPP
#define CUBE_WIDE_SEARCH_ENUMERATOR_CPP

#include "CubeWideSearchEnumerator.h"

#include <iostream>

using namespace cube;

row_of_objects_t*
WideSearchEnumerator::traverse( row_of_objects_t* row,  Vertex* root )
{
    if ( root == NULL )
    {
        return row;                                                 // no children any more ;
    }
    if ( root->get_parent() == NULL )
    {
        row->push_back( root );                                     // root has to be added specially.
    }
    for ( unsigned i = 0; i < root->num_children(); i++ )
    {
        row->push_back( root->get_child( i ) );
    }
    for ( unsigned i = 0; i < root->num_children(); i++ )
    {
        row = traverse( row, root->get_child( i ) );
    }
    return row;
}






#endif
