/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef __GENERAL_EVALUATION_CPP
#define __GENERAL_EVALUATION_CPP 0

#include "CubeGeneralEvaluation.h"
#include "CubePL1MemoryManager.h"

using namespace cube;

GeneralEvaluation::GeneralEvaluation()
{
};

GeneralEvaluation::~GeneralEvaluation()
{
    for ( vector<GeneralEvaluation*>::iterator iter = arguments.begin(); iter != arguments.end(); iter++ )
    {
        delete ( *iter );
    }
}


size_t
GeneralEvaluation::getNumOfParameters()
{
    return arguments.size();
}


size_t
GeneralEvaluation::getNumOfArguments()
{
    return 0;
}


void
GeneralEvaluation::addArgument( GeneralEvaluation* _arg )
{
    arguments.push_back( _arg );
}


double
GeneralEvaluation::eval()
{
    return 0;
}


#endif
