/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef __CONSTANT_EVALUATION_CPP
#define __CONSTANT_EVALUATION_CPP 0

#include "CubeConstantEvaluation.h"
using namespace cube;

ConstantEvaluation::ConstantEvaluation( double _const ) : NullaryEvaluation()
{
    constant = _const;
};

ConstantEvaluation::ConstantEvaluation( string _const ) : NullaryEvaluation()
{
    std::istringstream stream( _const );
    stream >> constant;
};

ConstantEvaluation::~ConstantEvaluation()
{
}

double
ConstantEvaluation::eval()
{
    return constant;
}


#endif
