/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef __CUBE_CALLTREE_CALLS_H
#define __CUBE_CALLTREE_CALLS_H


#include "CubeCnode.h"

using namespace cube;


/**
 * Prints the format of "usage" of this tool.
 */
void
usage( const char* argv )
{
    cout << "usage: " << argv << " -a -m metricname -f filename -h\n";
    exit( 0 );
}



/**
 * Recursiv counting of the level in a tree hierarchy of given cnode.
 */
int
get_level( const Cnode& c )
{
    Cnode* ptr = c.get_parent();
    int    level( 0 );
    while ( true )
    {
        if ( ptr == 0 )
        {
            break;
        }
        else
        {
            level++;
            ptr = ptr->get_parent();
        }
    }
    return level;
}


#endif
