/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/

#ifndef CUBE_DUMP_CSV_PRINTER
#define CUBE_DUMP_CSV_PRINTER

#include "cube4_dump_Printer.h"


class CSVPrinter : public Printer
{
public:
    CSVPrinter( ostream& _out,
                Cube*    _cube ) : Printer( _out, _cube )
    {
    }


    virtual
    void
    dump_data( std::vector < Metric* >& _metrics,
               std::vector < Cnode* >&  _cnodes,
               std::vector < Thread* >& _threads,
               CalculationFlavour       _mf,
               CalculationFlavour       _cf,
               bool                     stored,
               bool                     selected_all_threads ) const;

    virtual
    void
    dump_flat_profile(  std::vector < Metric* >& _metrics,
                        std::vector < Region* >& regions,
                        std::vector < Thread* >& _threads,
                        CalculationFlavour       _mf,
                        bool                     selected_all_threads ) const;
};

#endif
